"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var deeplinker_extension_resolver_1 = require("./deeplinker-extension-resolver");
var ionic_angular_1 = require("ionic-angular");
var IonicDeepLinkerExtesionModule = (function () {
    // injected here in the module to force to create the wrapper into the deepLinker
    function IonicDeepLinkerExtesionModule(deepLinker, deepLinkExtensionResolver) {
        this.deepLinkExtensionResolver = deepLinkExtensionResolver;
        this.wrapDeepLinker(deepLinker);
    }
    IonicDeepLinkerExtesionModule_1 = IonicDeepLinkerExtesionModule;
    IonicDeepLinkerExtesionModule.forRoot = function (resolver) {
        return {
            ngModule: IonicDeepLinkerExtesionModule_1,
            providers: [
                {
                    provide: deeplinker_extension_resolver_1.DeepLinkerExtensionResolver,
                    useValue: resolver
                }
            ]
        };
    };
    IonicDeepLinkerExtesionModule.prototype.wrapDeepLinker = function (deepLinker) {
        var _this = this;
        var deepLinkerOriginalFn = deepLinker.getComponentFromName.bind(deepLinker);
        deepLinker['getComponentFromName'] = function (name) {
            return deepLinkerOriginalFn(_this.deepLinkExtensionResolver(name));
        };
    };
    IonicDeepLinkerExtesionModule = IonicDeepLinkerExtesionModule_1 = __decorate([
        core_1.NgModule({
            providers: [
                {
                    provide: deeplinker_extension_resolver_1.DeepLinkerExtensionResolver,
                    useValue: deeplinker_extension_resolver_1.deepLinkerExtensionResolver
                }
            ]
        }),
        __param(1, core_1.Inject(deeplinker_extension_resolver_1.DeepLinkerExtensionResolver)),
        __metadata("design:paramtypes", [ionic_angular_1.DeepLinker, Function])
    ], IonicDeepLinkerExtesionModule);
    return IonicDeepLinkerExtesionModule;
    var IonicDeepLinkerExtesionModule_1;
}());
exports.IonicDeepLinkerExtesionModule = IonicDeepLinkerExtesionModule;
//# sourceMappingURL=deeplinker-extension.module.js.map